
#ifndef _COMBINAT_H
#define _COMBINAT_H

#include "primtypes.h"

natural_t binomial(natural_t n, natural_t r);
natural_t old_binomial(natural_t n, natural_t r);
bool first_kset(natural_t n, natural_t k, natural_t *pi);
bool next_kset(natural_t n, natural_t k, natural_t *ar);
natural_t kset_index(natural_t n, natural_t k, natural_t *pi);
natural_t kset_index_complete(natural_t n, natural_t k, natural_t *pi, array_index_t i, array_index_t last_i, array_index_t j, natural_t last, natural_t sum);
void bucket_sort(int n, int k, int *pi1, int *pi2);
natural_t kset_cindex(natural_t n, natural_t k, natural_t *pi);
bool set_contains(natural_t k, natural_t S[], natural_t e);
natural_t Gamma(natural_t n, natural_t d);
bool first_kpartition(natural_t n, natural_t k, natural_t *pi, natural_t *pibar, natural_t *tau);
bool next_kpartition(natural_t n, natural_t k, natural_t *pi, natural_t *pibar, natural_t *tau);
void which_kset(natural_t n, natural_t k, natural_t index, natural_t *pi);
void random_permutation(natural_t n, natural_t *pi);
extern void output_bindex(int n, int d, int b, int *pi);
extern void output_kset(int n, int d,  int *pi);
int kset_diff(int k, natural_t *pi1, natural_t *pi2, natural_t *out);
void init_reorder_table(int order, natural_t n, natural_t r, array_index_t *table);
int index_cmp(const void *ap, const void *bp);
int basis_parity(int r, int *basis);
int set_intersect(int, natural_t*, int, natural_t*,natural_t*);
#endif
