#ifndef _GPARAMS_H
#define _GPARAMS_H
/**
 * @file   gparams.h
 * @author David Bremner <bremner@pcgritzmann6.mathematik.tu-muenchen.de>
 * @date   Wed Dec  4 14:47:00 2002
 * 
 * @brief  Structure declaration for run time (command line) options
 * 
 * 
 */



#include <limits.h>
#include "oms_types.h"

typedef struct params_struct {
  natural_t	n,r;
  bool		restart;

  natural_t     success_count;
  natural_t	subtreelimit;
  char	checkpointname[PATH_MAX];
  char  restartname[PATH_MAX];
  char  inputfile[PATH_MAX];
  char  myname[PATH_MAX];
  array_index_t	checkpointtime;

  char		variable_order;

  array_index_t	first_root_basis,last_root_basis;

  #include "option_params.h"

} params_t, *params_p;

#endif
