/* z_time.h
   Executed on front end.

 * $Source$
 * $Revision: 2732 $
 * $Date: 2000-11-15 17:14:52 +0100 (Wed, 15 Nov 2000) $
 * $Log$
 * Revision 1.2  2000/11/15 16:14:52  bremner
 * committing patched version of zram source
 *
 * Revision 1.3  1997/10/17  12:16:46  marzetta
 * removed definition of TIME, added _Z_TIME_H_
 *
 * Revision 1.2  1995/09/14  12:25:16  marzetta
 * *** empty log message ***
 *
 * Revision 1.1  1995/08/22  12:42:50  marzetta
 * Initial revision
 *
 */

#ifndef _Z_TIME_H_
#define _Z_TIME_H_

double z_Wtime(void);
/* Return the number of seconds elapsed since some starting point
   (wall clock time). Must be saved as double, not as float.
 */

double z_Ptime(void);
/* Return the number of cpu seconds used by the current process.
   Must be saved as double, not as float.
 */

#define z_Gtime ((z_numprocs == 1) ? z_Ptime : z_Wtime)
/* General time measurement: elapsed time for parallel computers
                             cpu time for sequential computers. */

#endif /* _Z_TIME_H_ */
